function [detRate PCP R Rss Rs] = PARSE_eval_pcp(name,points,test,strparam)
% -------------------
% generate testing stick
% order: 'torso', 'ruleg', 'luleg', 'rlleg', 'llleg', 'ruarm', 'luarm', 'rlarm', 'llarm', 'head';
I = [1   1   2   2   3  4  5  6  7  8  9  10 11 12 13 14 15 16 17 18 19 20];
J = [9  10   3   4   3  2  4  5   2  1  5  6 9  8  10 11 8  7  11 12 14 13];
S = [1/2 1/2 1/2 1/2 1  1  1  1  1  1  1  1  1  1  1  1  1  1  1  1  1  1];
A = full(sparse(I,J,S,20,14));

ind14p = [strparam.ind14p*2-1; strparam.ind14p*2];
ind14p = ind14p(:);

for n = 1:length(test)
  pts = points{n}(:,ind14p);
  if isempty(pts)
    predstick(n).stickmen = [];
    continue;
  end    
  for i = 1:size(pts,1)
    predstick(n).stickmen(i).coor = reshape((A*reshape(pts(i,:),2,size(pts,2)/2)')',4,10);
  end
end

% -------------------
% create groundtruth stick
for n = 1:length(test)
  gtstick(n).stickmen.coor = reshape((A*test(n).point)',4,10);
end

% the PCP evaluation function originally comes from BUFFY dataset, we keep using that for performance evaluation
[detRate PCP R Rss Rs] = eval_pcp(name,predstick,gtstick);

