function [box,ex,ptr] = backtrack(x,y,mix,parts,pyra,ex,write)

fdim = size(pyra.feat{parts(1).level}, 3);

numparts = length(parts);
ptr = zeros(numparts,3);
box = zeros(numparts,4);
k   = 1;
p   = parts(k);
ptr(k,:) = [x y mix];

fid = p.ctmap(mix);

offsetx = ceil(p.sizx(fid)/2);
offsety = ceil(p.sizy(fid)/2);
scale = pyra.scale(p.level);
x1  = (x-offsetx+1)*scale+1;
y1  = (y-offsety+1)*scale+1;
x2  = x1 + p.sizx(fid)*scale - 1;
y2  = y1 + p.sizy(fid)*scale - 1;
box(k,:) = [x1 y1 x2 y2];

nblock = numparts*3-1;
if write,
  tmpid = ex.id;
  clear ex
  ex.id = tmpid;
  ex.id(3:5) = [p.level round(x+p.sizx(fid)/2) round(y+p.sizy(fid)/2)];
  ex.blocks(nblock) = struct('i', 1, 'x', []);
  cnt = 1;
  ex.blocks(cnt).i = p.biasI;
  ex.blocks(cnt).x   = 1;
  cnt = cnt+1;
  
  x = x+pyra.padx-offsetx+2;
  y = y+pyra.pady-offsety+2;
  xend = x+p.sizx(fid)-1;
  yend = y+p.sizy(fid)-1;
  ex.blocks(cnt).i = p.filterI(fid);
  ex.blocks(cnt).x = [fdim, x, xend, y, yend];
  cnt = cnt+1;
  
end
for k = 2:numparts,
  p   = parts(k);
  par = p.parent;
  x   = ptr(par,1);
  y   = ptr(par,2);
  mix = ptr(par,3);
  ptr(k,1) = p.Ix(y,x,mix);
  ptr(k,2) = p.Iy(y,x,mix);
  ptr(k,3) = p.Ik(y,x,mix);
  cx  = ptr(k,1);
  cy  = ptr(k,2);
  cmix = ptr(k,3);
  
  fid = p.ctmap(cmix);
  defid = p.ptnum*(cmix-1)+mix;
  
  scale = pyra.scale(p.level);
  offsetx = ceil(p.sizx(fid)/2);
  offsety = ceil(p.sizy(fid)/2);
  x1  = (cx-offsetx+1)*scale+1;
  y1  = (cy-offsety+1)*scale+1;
  x2  = x1 + p.sizx(fid)*scale - 1;
  y2  = y1 + p.sizy(fid)*scale - 1;
  box(k,:) = [x1 y1 x2 y2];
  
  if write
    ex.blocks(cnt).i = p.biasI(mix,cmix);
    ex.blocks(cnt).x   = 1;
    cnt = cnt+1;
    ex.blocks(cnt).i = p.defI(defid);
    
    dx = x-1+p.startx(defid)-cx;
    dy = y-1+p.starty(defid)-cy;
    ex.blocks(cnt).x   = -[dx*dx dx dy*dy dy];
    cnt = cnt+1;
    
    x = cx+pyra.padx-offsetx+2;
    y = cy+pyra.pady-offsety+2;
    xend = x+p.sizx(fid)-1;
    yend = y+p.sizy(fid)-1;
    ex.blocks(cnt).i = p.filterI(fid);
    ex.blocks(cnt).x = [fdim, x, xend, y, yend];
    cnt = cnt+1;
    
  end
end
box = reshape(box',1,4*numparts);
