function [idx, idx_map, posboxes] = clusterparts(pos,deffeat,scale,sbin)

global strparam

pa = strparam.pa;
K  = strparam.K;
P = strparam.numparts;
idx = cell(1,P);
idx_map = cell(1,P);
posboxes = cell(1,P);

for p = 1:P

    fprintf('   train visual clustering for part %d ... \n', p);
    
    if (length(pos(1).poselet{p}) > 2)
      % learn visual clustering for combined parts
      npos = length(pos);
      boxes = zeros(npos, 4);
      for id = 1:npos
        boxes(id, :) = [pos(id).x1(p), pos(id).y1(p), pos(id).x2(p), pos(id).y2(p)];
      end
      [idxp_new, Knew] = learnVisualCategoryTwophase(pos, boxes, scale, K(p), 10, sbin);
      idxp = idxp_new;
      K(p) = Knew;
      
    else
      if pa(p) == 0
        i = 1;
        while pa(i) ~= p
          i = i+1;
        end
        X = deffeat{i} - deffeat{p};
      else
        X = deffeat{p} - deffeat{pa(p)};
      end
      
      Y = [atan2(X(:,1), X(:,2)), sqrt(sum(X.^2, 2))/1e4];
      idxp = kmeans_wrap(Y, K(p), 100);
    end

    idx{p} = idxp;
    idx_map{p} = [1:K(p)];
end

strparam.K = K;


