function B = crop_image(im, wind, pad)
%
% im     : images
% wind   : [x1, y1, x2, y2]
% pad    : 0 - return valid patch (could be smaller than given 'wind')
%          1 - return full patch with padding be replicate boundary
%

row = size(im, 1);
col = size(im, 2);

wind = floor(wind);
crop = max(wind, [1 1 1 1]);
crop = min(crop, [col row col row]);

B = im(crop(2):crop(4), crop(1):crop(3), :);

if pad && (any(wind([1,2]) < 1) || wind(4) > row || wind(3) > col)
  prepad = [crop(2)-wind(2), crop(1)-wind(1)];
  prepad = max(prepad, 0);
  postpad = [wind(4)-crop(4), wind(3)-crop(3)];
  postpad = max(postpad, 0);
  B = padarray(B, prepad, 'replicate', 'pre');
  B = padarray(B, postpad, 'replicate', 'post');
end
