function [idx, ctr, min_dist, scores] = kmeans_wrap(X, C, iter)

if (C == 1)
  idx = ones(1, size(X,1));
  ctr = mean(X);
  return;
end

idx = [];
ctr = [];
min_dist = inf;
scores = [];
for i = 1:iter
  [idx_tmp, ctr_tmp, dist, scores_tmp] = k_means(X, C);
  if (dist < min_dist)
    idx = idx_tmp;
    ctr = ctr_tmp;
    min_dist = dist;
    scores = scores_tmp;
  end
end
