function [idx, K] = learnVisualCategoryTwophase(pos, boxes, scale, K, kmean_iter, sbin)

S = ceil(K/4);  % number of ratio aspects
if (K == 1)
  idx = ones(1, length(pos));
  boxes = [];
  return;
end

%% initial clustering in terms of poselet size
[raidx, raidxset, boxes] = clusterRatioAspect(boxes, scale, S, kmean_iter);
szNum = length(raidxset);

%% train visual category for each ratio set
idx = zeros(1, length(pos));
cnt = 0;
for k = 1:szNum
  szind = find(raidx==raidxset(k));
  if isempty(szind)
    continue;
  end
  
  Ksep = int32(K/2);
  Ksep = min(Ksep, length(szind)/3);
  Ksep = max(1, Ksep);
  [idxp, Knew] = learnVisualCategory(...
      pos(szind), boxes(szind,:), scale(szind), Ksep, kmean_iter, sbin);
  idx(szind) = idxp+cnt;

  cnt = cnt+Knew;
end
K = cnt;


