function qp = qp_init(model, maxnum, maxmem)

C = 0.002;
wpos = 2;

if (nargin < 3)
  maxmem = 0.5;  % 500M for save allocation
end

len  = sparselen(model);
nmax = round(maxmem*.25e9/len);
nmax = min(nmax, maxnum);

qp.x   = zeros(len,nmax,'single');
qp.i   = zeros(5,nmax,'int32');
qp.b   = ones(nmax,1,'single');
qp.d   = zeros(nmax,1,'double');
qp.a   = zeros(nmax,1,'double');
qp.sv  = logical(zeros(1,nmax));  
qp.n   = 0;
qp.obj = [];

[qp.w,qp.wreg,qp.w0,qp.noneg] = model2vec(model);
qp.Cpos = C*wpos;
qp.Cneg = C;
qp.w    = (qp.w - qp.w0).*qp.wreg;

