% Prunes qp to current active constraints (eg., support vectors)
function n = qp_prune()
global qp

% if cache is full of support vectors, only keep non-zero (and fixed) ones
if all(qp.sv),
  qp.sv = qp.a > 0;
  qp.sv(qp.svfix) = 1;
end

I = find(qp.sv > 0);

I = I(end:-1:1);
n = length(I);
assert(n > 0);

% E = find(qp.sv(1:n) <= 0);
E = setdiff([1:n], I)';
n0 = length(E);
I2 = I(I>n);
n1 = length(I2);
assert(n1 >= n0);

qp.l = 0;
qp.w = zeros(size(qp.w));
k    = length(qp.w);

I = I(I>n);
qp_prune_cc(qp, E, I, n);

qp.sv(1:n)     = 1;
qp.sv(n+1:end) = 0;
qp.a(n+1:end)  = 0;
qp.w(qp.noneg) = max(qp.w(qp.noneg),0);
qp.obj = qp.l - qp.w'*qp.w*.5;
qp.n   = n;
fprintf(' Pruned to %d/%d with dual=%.4f \n',qp.n,length(qp.a),qp.obj);  


