function model = trainmodel(name,pos,neg,strparam,sbin,suffix)

global cachedir opts
K = strparam.K;
pa = strparam.pa;
numpart = length(pa);

cls = [name '_cluster_' suffix];
load([cachedir cls]);

def = data_def(pos, scale, sbin);

for p = 1:numpart
  cls = [name '_part_' num2str(p) '_mix_' num2str(K(p))];
  try
    load([cachedir cls]);
  catch
    sneg = neg(1:min(length(neg),100));
    models = cell(1,K(p));
    for k = 1:K(p)
      spos = pos(idx{p} == k);
      for n = 1:length(spos)
        spos(n).x1 = spos(n).x1(p);
        spos(n).y1 = spos(n).y1(p);
        spos(n).x2 = spos(n).x2(p);
        spos(n).y2 = spos(n).y2(p);
      end
      model = initmodel(spos,1,sbin,scale(idx{p}==k));
      model = train(cls,model,spos,sneg,1,1);
      models{k} = model;
    end
    
    model = mergemodels(models);
    save([cachedir cls],'model');
  end
end

if ~exist('idx_map', 'var')
  numpart = length(K);
  idx_map = cell(1, numpart);
  for pi = 1:numpart
    idx_map{pi} = [1:max(idx{pi})];
  end
end


cls = [name '_final_' suffix];
try
  load([cachedir cls]);  
catch
  model = buildmodel(name,model,pa,def,idx,idx_map,K);

  model = train(cls,model,pos,neg,0,opts.train_iter);
  save([cachedir cls],'model');
end


