function pos = trainvisualcluster(name,pos,scale,sbin,suffix)

global cachedir strparam
P = strparam.numparts;

cls = [name '_cluster_' suffix];
try
  load([cachedir cls]);
  for pi = 1:P
    idx_uni = unique(idx{pi});
    strparam.K(pi) = length(idx_uni);
  end
catch
  [def] = data_def(pos,scale,sbin);
  [idx, idx_map, posboxes] = clusterparts(pos,def,scale,sbin);  
  save([cachedir cls],'def', 'scale', 'idx', 'idx_map','posboxes');
end

% assign updated boxes to positive samples
if exist('posboxes','var') && ~isempty(posboxes)
  npos = length(pos);
  for p = 1:P
    if isempty(posboxes{p}), continue; end
    for id = 1:npos
      pos(id).x1(p) = posboxes{p}(id,1);
      pos(id).y1(p) = posboxes{p}(id,2);
      pos(id).x2(p) = posboxes{p}(id,3);
      pos(id).y2(p) = posboxes{p}(id,4);
    end
  end
end

