function pos = pointtobox(pos,strparam,boxsize)

npos = length(pos);
nt = strparam.numparts;

for n = 1:npos
    points = pos(n).point;
    
    pos(n).x1 = zeros(1, nt);
    pos(n).y1 = zeros(1, nt);
    pos(n).x2 = zeros(1, nt);
    pos(n).y2 = zeros(1, nt);
    margin = boxsize(n)/2;
    
    % create boxes for combined parts
    for p = 1:nt
      if (length(pos(n).poselet{p}) > 2)
        poseletx = pos(n).poselet{p}(1:2:end);
        poselety = pos(n).poselet{p}(2:2:end);
        pos(n).x1(p) = min(poseletx) - margin;
        pos(n).y1(p) = min(poselety) - margin;
        pos(n).x2(p) = max(poseletx) + margin;
        pos(n).y2(p) = max(poselety) + margin;
        
      else
        pos(n).x1(p) = points(p,1) - margin;
        pos(n).y1(p) = points(p,2) - margin;
        pos(n).x2(p) = points(p,1) + margin;
        pos(n).y2(p) = points(p,2) + margin;
      end
    end
end